-- name: [CS] Paper Partners TTYD 3.3
-- description: Skinpack of famous friends from the Paper Mario series! \n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local E_MODEL_GOOMBELLA = smlua_model_util_get_id("goombella_geo")
local E_MODEL_KOOPS = smlua_model_util_get_id("koops_geo")
local E_MODEL_BOBBERY = smlua_model_util_get_id("bobbery_geo")
local E_MODEL_MOWZ = smlua_model_util_get_id("mowz_geo")
local E_MODEL_FLURRIE = smlua_model_util_get_id("flurrie_geo")
local E_MODEL_BY_G_1 = smlua_model_util_get_id("byoshi_g_1_geo")
local E_MODEL_BY_R_2 = smlua_model_util_get_id("byoshi_r_2_geo")
local E_MODEL_BY_B_3 = smlua_model_util_get_id("byoshi_b_3_geo")
local E_MODEL_BY_O_4 = smlua_model_util_get_id("byoshi_o_4_geo")
local E_MODEL_BY_WM_5 = smlua_model_util_get_id("byoshi_wm_5_geo")
local E_MODEL_BY_BK_6 = smlua_model_util_get_id("byoshi_bk_6_geo")
local E_MODEL_BY_W_7 = smlua_model_util_get_id("byoshi_w_7_geo")
local E_MODEL_VIVIAN = smlua_model_util_get_id("vivian_geo")

local TEX_GOOMBELLA = get_texture_info("goombella_icon")
local TEX_KOOPS = get_texture_info("koops_icon")
local TEX_BOBBERY = get_texture_info("bobbery_icon")
local TEX_MOWZ = get_texture_info("mowz_icon")
local TEX_FLURRIE = get_texture_info("flurrie_icon")
local TEX_BY_G_1 = get_texture_info("by_g_1")
local TEX_BY_R_2 = get_texture_info("by_r_2")
local TEX_BY_B_3 = get_texture_info("by_b_3")
local TEX_BY_O_4 = get_texture_info("by_o_4")
local TEX_BY_WM_5 = get_texture_info("by_wm_5")
local TEX_BY_BK_6 = get_texture_info("by_bk_6")
local TEX_BY_W_7 = get_texture_info("by_w_7")
local TEX_VIVIAN = get_texture_info("vivian_icon")

local E_MODEL_STAR_CRYSTAL = smlua_model_util_get_id("crystal_star_geo")
local TEX_STAR_CRYSTAL = get_texture_info("star_c_crystal")

local E_MODEL_STAR_DIAMOND = smlua_model_util_get_id("diamond_star_geo")
local TEX_STAR_DIAMOND = get_texture_info("star_c_diamond")

local E_MODEL_STAR_EMERALD = smlua_model_util_get_id("emerald_star_geo")
local TEX_STAR_EMERALD = get_texture_info("star_c_emerald")

local E_MODEL_STAR_GOLD = smlua_model_util_get_id("gold_star_geo")
local TEX_STAR_GOLD = get_texture_info("star_c_gold")

local E_MODEL_STAR_RUBY = smlua_model_util_get_id("ruby_star_geo")
local TEX_STAR_RUBY = get_texture_info("star_c_ruby")

local E_MODEL_STAR_SAPPHIRE = smlua_model_util_get_id("sapphire_star_geo")
local TEX_STAR_SAPPHIRE = get_texture_info("star_c_sapphire")

local E_MODEL_STAR_GARNET = smlua_model_util_get_id("garnet_star_geo")
local TEX_STAR_GARNET = get_texture_info("star_c_garnet")



local TEXT_MOD_NAME = "[CS] Paper Partners TTYD"

local VOICETABLE_GOOMBA = {
    [CHAR_SOUND_YAH_WAH_HOO] = 'Gyah.ogg',
    [CHAR_SOUND_HOOHOO] = 'Ghoohoo (2).ogg',
    [CHAR_SOUND_YAHOO] = 'Gyahooyipee.ogg',
    [CHAR_SOUND_UH] = 'Guh2coughing2.ogg',
    [CHAR_SOUND_HRMM] = 'Ghrm.ogg',
    [CHAR_SOUND_WAH2] = 'Gwah.ogg',
    [CHAR_SOUND_WHOA] = 'Gwhoa.ogg',
    [CHAR_SOUND_EEUH] = 'Geeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'Gattacked.ogg',
    [CHAR_SOUND_OOOF] = 'Gooof.ogg',
    [CHAR_SOUND_OOOF2] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Ghere we go.ogg',
    [CHAR_SOUND_YAWNING] = 'Gyawning.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Gwaaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'Ghaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Ghaha.ogg',
    [CHAR_SOUND_UH2] = 'Guh.ogg',
    [CHAR_SOUND_UH2_2] = 'Guh2_2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Gfire.ogg',
    [CHAR_SOUND_DYING] = 'Gdying.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_PANTING] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_COUGHING1] = 'Gcoughing.ogg',
    [CHAR_SOUND_COUGHING2] = 'Guh2coughing2.ogg',
    [CHAR_SOUND_COUGHING3] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Gyah (2).ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Ghoohoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Gsurprise.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Gwah.ogg',
    [CHAR_SOUND_DROWNING] = 'Gdrowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Gwah_punch.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'Gyahooyipee.ogg',
    [CHAR_SOUND_DOH] = 'Gdoh.ogg',
    [CHAR_SOUND_HELLO] = 'Ghello.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Gquestion.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Gsolongabowser.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'Gimatired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Gletsago.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Goki doki.ogg',
}

local VOICETABLE_KOOPA = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'Kya.ogg', 'Kwah.ogg' },
    [CHAR_SOUND_HOOHOO] = 'Khoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'Kyahoo.ogg',
    [CHAR_SOUND_UH] = 'Kuh.ogg',
    [CHAR_SOUND_HRMM] = 'Khrm.ogg',
    [CHAR_SOUND_WAH2] = 'Kwah.ogg',
    [CHAR_SOUND_WHOA] = 'Kwhoa.ogg',
    [CHAR_SOUND_EEUH] = 'Keh.ogg',
    [CHAR_SOUND_ATTACKED] = 'Kdoh.ogg',
    [CHAR_SOUND_OOOF] = 'Khurt.ogg',
    [CHAR_SOUND_OOOF2] = 'Keh2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Ktwirl_bounce.ogg',
    [CHAR_SOUND_YAWNING] = 'Kyawning.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Kwoaaaw.ogg',
    [CHAR_SOUND_HAHA] = 'Khaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Khaha.ogg',
    [CHAR_SOUND_UH2] = 'Kuh.ogg',
    [CHAR_SOUND_UH2_2] = 'Kuh2-2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Kfire.ogg',
    [CHAR_SOUND_DYING] = 'Kdying.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'Kcoughing2.ogg',
    [CHAR_SOUND_PANTING] = 'Kcoughing2.ogg',
    [CHAR_SOUND_COUGHING1] = 'Kcoughing2.ogg',
    [CHAR_SOUND_COUGHING2] = 'Kcoughing3.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Kyah2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Khoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Kwoaaaw.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Kwah2.ogg',
    [CHAR_SOUND_DROWNING] = 'Kdrowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Kwah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'Ksolonga_bowser.ogg', 'Ktwirl_bounce.ogg' },
    [CHAR_SOUND_DOH] = 'Kdoh.ogg',
    [CHAR_SOUND_HELLO] = 'Khello.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Ktwirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Ksolonga_bowser.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'Khurt.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Klets a go.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Kokey_dokey.ogg',
}

local VOICETABLE_BOBOMB = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'Bo_yah.ogg', 'Bo_yah2.ogg' },
    [CHAR_SOUND_HOOHOO] = 'Bo_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'Bo_yahoo.ogg',
    [CHAR_SOUND_UH] = 'Bo_uh.ogg',
    [CHAR_SOUND_HRMM] = 'Bo_hrmm.ogg',
    [CHAR_SOUND_WAH2] = 'Bo_wah2.ogg',
    [CHAR_SOUND_WHOA] = 'Bo_whoa.ogg',
    [CHAR_SOUND_EEUH] = 'Bo_eeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'Bo_attacked.ogg',
    [CHAR_SOUND_OOOF] = 'Bo_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'Bo_ooof2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Bo_herewego.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Bo_waaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'Bo_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Bo_haha_2.ogg',
    [CHAR_SOUND_UH2] = 'Bo_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'Bo_uh2_2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Bo_onfire.ogg',
    [CHAR_SOUND_DYING] = 'Bo_dying.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'Bo_panting_cold.ogg',
    [CHAR_SOUND_PANTING] = 'Bo_panting.ogg',
    [CHAR_SOUND_COUGHING1] = 'Bo_coughing.ogg',
    [CHAR_SOUND_COUGHING2] = 'Bo_coughing2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Bo_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Bo_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Bo_mama_mia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Bo_groundpound.ogg',
    [CHAR_SOUND_DROWNING] = 'Bo_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Bo_punch_wah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'Bo_yahoo.ogg', 'Bo_waha.ogg', 'Bo_wihee.ogg' },
    [CHAR_SOUND_DOH] = 'Bo_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Bo_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Bo_solongabowser.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Bo_letsago.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Bo_okey_dokey.ogg',
}

local VOICETABLE_MOWZ = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'ms_jump.ogg', 'ms_jump3.ogg' },
    [CHAR_SOUND_HOOHOO] = 'ms_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'ms_yahoo.ogg',
    [CHAR_SOUND_UH] = 'ms_uh.ogg',
    [CHAR_SOUND_HRMM] = 'ms_eeuh.ogg',
    [CHAR_SOUND_WAH2] = 'ms_ground_pound.ogg',
    [CHAR_SOUND_WHOA] = 'ms_whoa.ogg',
    [CHAR_SOUND_EEUH] = 'ms_eeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'ms_hurt.ogg',
    [CHAR_SOUND_OOOF] = 'ms_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'ms_ooof.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'ms_here_we_go.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'ms_waaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'ms_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'ms_haha.ogg',
    [CHAR_SOUND_UH2] = 'ms_uh.ogg',
    [CHAR_SOUND_UH2_2] = 'ms_uh.ogg',
    [CHAR_SOUND_ON_FIRE] = 'ms_on_fire.ogg',
    [CHAR_SOUND_DYING] = 'ms_dying.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'ms_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'ms_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'ms_mama_mia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'ms_ground_pound.ogg',
    [CHAR_SOUND_DROWNING] = 'ms_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'ms_ground_pound.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'ms_yahoo.ogg', 'ms_waha.ogg', 'ms_yipee.ogg' },
    [CHAR_SOUND_DOH] = 'ms_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'ms_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'ms_twirl_bounce.ogg',
}
local VOICETABLE_FLURRIE = {
    [CHAR_SOUND_ATTACKED] = 'fl_attacked.ogg',
    [CHAR_SOUND_COUGHING1] = 'fl_coughing1.ogg',
    [CHAR_SOUND_COUGHING2] = 'fl_coughing2.ogg',
    [CHAR_SOUND_COUGHING3] = 'fl_coughing3.ogg',
    [CHAR_SOUND_DOH] = 'fl_doh.ogg',
    [CHAR_SOUND_DROWNING] = 'fl_dying.ogg',
    [CHAR_SOUND_DYING] = 'fl_dying.ogg',
    [CHAR_SOUND_EEUH] = 'fl_eeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'fl_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'fl_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'fl_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'fl_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'fl_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'fl_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'fl_mama_mia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'fl_letsa_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'fl_on_fire.ogg',
    [CHAR_SOUND_OOOF] = 'fl_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'fl_ooof2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'fl_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'fl_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'fl_punch_yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'fl_so_longa_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'fl_yah5.ogg',
    [CHAR_SOUND_UH] = 'fl_uh.ogg',
    [CHAR_SOUND_UH2] = 'fl_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'fl_uh2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'fl_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'fl_yah2.ogg',
    [CHAR_SOUND_WHOA] = 'fl_whoa.ogg',
    [CHAR_SOUND_YAHOO] = 'fl_yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'fl_yahoo.ogg', 'fl_yahoo1.ogg', 'fl_yahoo2.ogg', 'fl_yahoo3.ogg' },
    [CHAR_SOUND_YAH_WAH_HOO] = { 'fl_yah1.ogg', 'fl_yah2.ogg', 'fl_yah3.ogg', 'fl_yah4.ogg', 'fl_yah5.ogg' },
}
local VOICETABLE_BY = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'by_yah1.ogg', 'by_yah2.ogg', 'by_yah3.ogg', 'by_yah4.ogg' },
    [CHAR_SOUND_HOOHOO] = 'by_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'by_yahoo.ogg',
    [CHAR_SOUND_UH] = 'by_uh.ogg',
    [CHAR_SOUND_HRMM] = 'by_hrmm.ogg',
    [CHAR_SOUND_WAH2] = 'by_yah2.ogg',
    [CHAR_SOUND_WHOA] = 'by_whoa.ogg',
    [CHAR_SOUND_EEUH] = 'by_eeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'by_attacked.ogg',
    [CHAR_SOUND_OOOF] = 'by_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'by_ooof2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'by_here_we_go.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'by_waaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'by_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'by_haha.ogg',
    [CHAR_SOUND_UH2] = 'by_uh.ogg',
    [CHAR_SOUND_UH2_2] = 'by_uh.ogg',
    [CHAR_SOUND_ON_FIRE] = 'by_on_fire.ogg',
    [CHAR_SOUND_DYING] = 'by_dying.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'by_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'by_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'by_mama_mia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'by_ground_pound_wah.ogg',
    [CHAR_SOUND_DROWNING] = 'by_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'by_punch_wah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'by_yahoo.ogg', 'by_yahoo1.ogg', 'by_yahoo2.ogg', 'by_yahoo3.ogg', 'by_yahoo4.ogg', 'by_yahoo5.ogg' },
    [CHAR_SOUND_DOH] = 'by_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'by_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'by_so_longa_bowser.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'by_lets_a_go.ogg',
}

local VOICETABLE_VIVIAN = {
    [CHAR_SOUND_ATTACKED] = 'viv_attacked.ogg',
    [CHAR_SOUND_COUGHING1] = 'viv_coughing1.ogg',
    [CHAR_SOUND_COUGHING2] = 'viv_coughing2.ogg',
    [CHAR_SOUND_COUGHING3] = 'viv_coughing3.ogg',
    [CHAR_SOUND_DOH] = 'viv_doh.ogg',
    [CHAR_SOUND_DROWNING] = 'viv_drowning.ogg',
    [CHAR_SOUND_DYING] = 'viv_dying.ogg',
    [CHAR_SOUND_EEUH] = 'viv_eeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'viv_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'viv_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'viv_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'viv_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'viv_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'viv_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'viv_mama_mia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'viv_lets_a_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'viv_on_fire.ogg',
    [CHAR_SOUND_OOOF] = 'viv_oof.ogg',
    [CHAR_SOUND_OOOF2] = 'viv_oof2.ogg',
    [CHAR_SOUND_PANTING] = { 'viv_panting1.ogg', 'viv_panting2.ogg', 'viv_panting3.ogg' },
    [CHAR_SOUND_PUNCH_HOO] = 'viv_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'viv_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'viv_punch_yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'viv_so_longa_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'viv_twirl_bounce.ogg',
    [CHAR_SOUND_UH] = 'viv_uh.ogg',
    [CHAR_SOUND_UH2] = 'viv_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'viv_uh2_2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'viv_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'viv_yah2.ogg',
    [CHAR_SOUND_WHOA] = 'viv_woah.ogg',
    [CHAR_SOUND_YAHOO] = 'viv_yipee.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'viv_yipee.ogg', 'viv_yipee1.ogg', 'viv_yipee2.ogg', 'viv_yipee3.ogg', 'viv_yipee4.ogg' },
    [CHAR_SOUND_YAH_WAH_HOO] = { 'viv_yah1.ogg', 'viv_yah2.ogg', 'viv_yah3.ogg', 'viv_yah4.ogg' },
}


local VOICETABLE_SILENT = { nil }

local capGoombella = {
    normal = smlua_model_util_get_id("goombellas_cap_geo"),
    wing = smlua_model_util_get_id("goombellas_wing_cap_geo"),
    metal = smlua_model_util_get_id("goombellas_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("goombellas_metal_wing_cap_geo")
}





local capKoops = {
    normal = smlua_model_util_get_id("koopss_cap_geo"),
    wing = smlua_model_util_get_id("koopss_wing_cap_geo"),
    metal = smlua_model_util_get_id("koopss_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("koopss_metal_wing_cap_geo")
}



local capBobbery = {
    normal = smlua_model_util_get_id("bobbery_cap_geo"),
    wing = smlua_model_util_get_id("bobbery_wing_cap_geo"),
    metal = smlua_model_util_get_id("bobbery_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("bobbery_metal_cap_geo")
}


local capBow = {
    normal = smlua_model_util_get_id("bow_cap_geo"),
    wing = smlua_model_util_get_id("bow_wing_cap_geo"),
    metal = smlua_model_util_get_id("bow_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("bow_metal_wing_cap_geo")
}


local capMowz = {
    normal = smlua_model_util_get_id("mowz_cap_geo"),
    wing = smlua_model_util_get_id("mowz_wing_cap_geo"),
    metal = smlua_model_util_get_id("mowz_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("mowz_metal_wing_cap_geo")
}
local capFlurrie = {
    normal = smlua_model_util_get_id("flurrie_cap_geo"),
    wing = smlua_model_util_get_id("flurrie_wing_cap_geo"),
    metal = smlua_model_util_get_id("flurrie_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("flurrie_metal_wing_cap_geo")
}
local capBy = {
    normal = smlua_model_util_get_id("byoshi_cap_geo"),
    wing = smlua_model_util_get_id("byoshi_wing_cap_geo"),
    metal = smlua_model_util_get_id("byoshi_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("byoshi_metal_wing_cap_geo")
}




local capVivian = {
    normal = smlua_model_util_get_id("vivian_cap_geo"),
    wing = smlua_model_util_get_id("vivian_wing_cap_geo"),
    metal = smlua_model_util_get_id("vivian_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("vivian_metal_wing_cap_geo")
}







local PALETTE_GOOMBELLA = {
    [PANTS]  = "f00000",
    [SHIRT]  = "bcbe91",
    [SHOES]  = "9c4118",
    [HAIR]   = "efb218",
    [SKIN]   = "d69781",
    [CAP]    = "b7be91",
    [GLOVES] = "ffffff",
}


local PALETTE_KOOPS = {
    [PANTS]  = "1d598f",
    [SHIRT]  = "4ea230",
    [GLOVES] = "ddd9cf",
    [SHOES]  = "b6875e",
    [HAIR]   = "f7b218",
    [SKIN]   = "f3b15d",
    [CAP]    = "a8bbd3",
}





local PALETTE_BOBBERY = {
    [PANTS]  = "4f4fc8",
    [SHIRT]  = "68461c",
    [GLOVES] = "ffffff",
    [SHOES]  = "C8A12F",
    [HAIR]   = "AAAAAA",
    [SKIN]   = "C8A12F",
    [CAP]    = "3F4851",
}

local PALETTE_LADY_BOW = {
    [PANTS]  = "d6d65a",
    [SHIRT]  = "f74a31",
    [GLOVES] = "cdfddf",
}



local PALETTE_MADAME_FLURRIE = {
    [PANTS] = "458c69",
    [SHIRT] = "8786d8",
    [SKIN]  = "fee65e",
    [CAP]   = "8786d8",
}

local PALETTE_VIVIAN = {
    [PANTS]  = "E61549",
    [SHIRT]  = "730E79",
    [GLOVES] = "EEEEEE",
    [SKIN]   = "FFA9A4",
}

local PALETTE_MS_MOWZ = {
    [SHIRT]  = "ff0000",
    [GLOVES] = "ffffff",
    [SHOES]  = "000000",
    [HAIR]   = "3c0000",
    [CAP]    = "ff0000",
}



local PALETTE_YOSHI_GREEN = {
    [PANTS]  = "cc120d",
    [SHIRT]  = "4bbf20",
    [GLOVES] = "ffffff",
    [HAIR]   = "cc120d",
    [SKIN]   = "d3b718",
    [CAP]    = "e79418",
}

local PALETTE_YOSHI_RED = {
    [PANTS]  = "099455",
    [SHIRT]  = "dd3553",
    [GLOVES] = "ffffff",
    [HAIR]   = "099455",
    [SKIN]   = "d3b718",
    [CAP]    = "535248",
}

local PALETTE_YOSHI_BLUE = {
    [PANTS]  = "de5f95",
    [SHIRT]  = "297ade",
    [GLOVES] = "ffffff",
    [HAIR]   = "de5f95",
    [SKIN]   = "ffffff",
    [CAP]    = "72c5b9",
}

local PALETTE_YOSHI_ORANGE = {
    [PANTS]  = "447ddb",
    [SHIRT]  = "ef7529",
    [GLOVES] = "ffffff",
    [HAIR]   = "447ddb",
    [SKIN]   = "d3b718",
    [CAP]    = "58a93a",
}

local PALETTE_YOSHI_WATERMELON = {
    [PANTS]  = "d53a80",
    [SHIRT]  = "ef90bc",
    [GLOVES] = "ffffff",
    [HAIR]   = "4bbf20",
    [SKIN]   = "ef90bc",
    [CAP]    = "dd3553",
}

local PALETTE_YOSHI_BLACK = {
    [PANTS]  = "f6bb2d",
    [SHIRT]  = "5a595a",
    [GLOVES] = "ffffff",
    [HAIR]   = "dd3553",
    [SKIN]   = "d3b718",
    [CAP]    = "8f8f90",
}

local PALETTE_YOSHI_WHITE = {
    [PANTS]  = "d53a80",
    [SHIRT]  = "bdd7e7",
    [GLOVES] = "ffffff",
    [HAIR]   = "f7db52",
    [SKIN]   = "f4ca3c",
    [CAP]    = "ffffff",
}





local char_add, char_add_caps, char_add_palette, char_add_voice, char_add_star, char_get_voice =
    _G.charSelect.character_add, _G.charSelect.character_add_caps, _G.charSelect.character_add_palette_preset,
    _G.charSelect.character_add_voice, _G.charSelect.character_add_celebration_star, _G.charSelect.character_get_voice

char_add_caps(E_MODEL_GOOMBELLA, capGoombella)

char_add_caps(E_MODEL_KOOPS, capKoops)

char_add_caps(E_MODEL_BOBBERY, capBobbery)

char_add_caps(E_MODEL_MOWZ, capMowz)
char_add_caps(E_MODEL_FLURRIE, capFlurrie)
char_add_caps(E_MODEL_BY_G_1, capBy)
char_add_caps(E_MODEL_BY_R_2, capBy)
char_add_caps(E_MODEL_BY_B_3, capBy)
char_add_caps(E_MODEL_BY_O_4, capBy)
char_add_caps(E_MODEL_BY_WM_5, capBy)
char_add_caps(E_MODEL_BY_BK_6, capBy)
char_add_caps(E_MODEL_BY_W_7, capBy)

char_add_caps(E_MODEL_VIVIAN, capVivian)


local PM_GOOMBELLA = {
    label = {
        left = get_texture_info("goombella_pm1"),
        right = get_texture_info("goombella_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}

local PM_KOOPA = {
    label = {
        left = get_texture_info("koopa_pm1"),
        right = get_texture_info("koopa_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}

local PM_FLURRIE = {
    label = {
        left = get_texture_info("flurrie_pm1"),
        right = get_texture_info("flurrie_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}

local PM_BYOSHI = {
    label = {
        left = get_texture_info("byoshi_pm1"),
        right = get_texture_info("byoshi_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}

local PM_VIVIAN = {
    label = {
        left = get_texture_info("vivian_pm1"),
        right = get_texture_info("vivian_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}

local PM_BOBBERY = {
    label = {
        left = get_texture_info("bobbery_pm1"),
        right = get_texture_info("bobbery_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}

local PM_MOWZ = {
    label = {
        left = get_texture_info("mowz_pm1"),
        right = get_texture_info("mowz_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}



if not _G.charSelectExists then
    djui_popup_create(
        "\\#ffffdc\\\n" ..
        TEXT_MOD_NAME ..
        "\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!",
        6)
    return
end


CT_GOOMBELLA = char_add("Goombella",
    "A female archaeology student at the University of Goom. She can be recognized by her ponytail and pith helmet that features a light that aids her archeological aspirations. With her wealth of knowledge, Goombella serves as Mario's tour guide and assists throughout his adventures. Goooo GOOMBAS!",
    "Melzinoff", { r = 175, g = 179, b = 150 }, E_MODEL_GOOMBELLA, CT_TOAD, TEX_GOOMBELLA)
CT_KOOPS = char_add("Koops",
    "Koops is a timid Koopa who wants to be tougher. Kicking some shell never felt so good.", "Melzinoff",
    { r = 166, g = 177, b = 190 }, E_MODEL_KOOPS, CT_LUIGI, TEX_KOOPS)
CT_FLURRIE = char_add("Flurrie",
    "Madame Flurrie was a retired actress, just dreaming of coming out of retirement when Mario and friends asked for her help with a small task. She found their stories of adventure alluring, and decided that she would come with them to help as much as she could. Voiced by Lucina Of Stardust",
    "Melzinoff & Lucina Of Stardust", { r = 183, g = 171, b = 206 }, E_MODEL_FLURRIE, CT_WARIO, TEX_FLURRIE)
CT_BY = char_add("Baby Yoshi (Green)",
    { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "Classic Green flavor!" },
    "Melzinoff, Sounds by ordatz", { r = 80, g = 250, b = 80 }, E_MODEL_BY_G_1, CT_MARIO, TEX_BY_G_1)
CT_VIVIAN = char_add("Vivian",
    "The youngest of the Shadow Sirens, she joins Mario when he shows her an act of kindness. She's the cutest and Transest character in this pack <3, Voiced by wibblus",
    "Melzinoff, wibblus", { r = 163, g = 17, b = 168 }, E_MODEL_VIVIAN, CT_MARIO, TEX_VIVIAN)
CT_BOBBERY = char_add("Admiral Bobbery",
    "Admiral Bobbery is a salty old Bob-omb sailor. who was once married to the lovely Scarlette. The workers at the docks say he is some kind of legend.",
    "Melzinoff", { r = 115, g = 78, b = 29 }, E_MODEL_BOBBERY, CT_WARIO, TEX_BOBBERY)
CT_MOWZ = char_add("Ms Mowz",
    "That's Ms. Mowz, the thief. She jets off to exotic locales to hunt for rare badges.", "Melzinoff",
    { r = 206, g = 65, b = 0 }, E_MODEL_MOWZ, CT_MARIO, TEX_MOWZ)


do
    -- table of skins
    local SKINTABLE_BY = {
        { model = E_MODEL_BY_R_2,  name = "Baby Yoshi (Red)",    desc = { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "Strawberry style!" },          color = { r = 255, g = 110, b = 110 }, icon = TEX_BY_R_2 },
        { model = E_MODEL_BY_B_3,  name = "Baby Yoshi (Blue)",   desc = { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "BlueBerry Blast!" },           color = { r = 100, g = 150, b = 250 }, icon = TEX_BY_B_3 },
        { model = E_MODEL_BY_O_4,  name = "Baby Yoshi (Orange)", desc = { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "Orange Juice all the way!" },  color = { r = 255, g = 150, b = 80 },  icon = TEX_BY_O_4 },
        { model = E_MODEL_BY_WM_5, name = "Baby Yoshi (Pink)",   desc = { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "Fresh Watermelon Pink!" },     color = { r = 255, g = 160, b = 180 }, icon = TEX_BY_WM_5 },
        { model = E_MODEL_BY_BK_6, name = "Baby Yoshi (Black)",  desc = { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "Rebellious Licorice Taste!" }, color = { r = 150, g = 150, b = 150 }, icon = TEX_BY_BK_6 },
        { model = E_MODEL_BY_W_7,  name = "Baby Yoshi (White)",  desc = { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "Vanilla Ice Cream!" },         color = { r = 225, g = 225, b = 255 }, icon = TEX_BY_W_7 }
    }

    for index, alt in ipairs(SKINTABLE_BY) do
        _G.charSelect.character_add_costume(CT_BY, alt.name, alt.desc, nil, alt.color, alt.model, nil, alt.icon, nil, nil)
    end
end

char_add_palette(E_MODEL_GOOMBELLA, PALETTE_GOOMBELLA)
char_add_palette(E_MODEL_KOOPS, PALETTE_KOOPS)
char_add_palette(E_MODEL_VIVIAN, PALETTE_VIVIAN)
char_add_palette(E_MODEL_BOBBERY, PALETTE_BOBBERY)
char_add_palette(E_MODEL_MOWZ, PALETTE_MS_MOWZ)
char_add_palette(E_MODEL_FLURRIE, PALETTE_MADAME_FLURRIE)
char_add_palette(E_MODEL_BY_G_1, PALETTE_YOSHI_GREEN)
char_add_palette(E_MODEL_BY_R_2, PALETTE_YOSHI_RED)
char_add_palette(E_MODEL_BY_B_3, PALETTE_YOSHI_BLUE)
char_add_palette(E_MODEL_BY_O_4, PALETTE_YOSHI_ORANGE)
char_add_palette(E_MODEL_BY_WM_5, PALETTE_YOSHI_WATERMELON)
char_add_palette(E_MODEL_BY_BK_6, PALETTE_YOSHI_BLACK)
char_add_palette(E_MODEL_BY_W_7, PALETTE_YOSHI_WHITE)

---- BOWSER Compatibility:
if _G.bowsMoveset then
    -- Retrieves the custom shell model for this character. Check template_shell.blend for how to set up a shell model properly.
    local E_MODEL_SHELL = smlua_model_util_get_id("kooper_shell_geo")


    -- This is a bitfield of flags that decide which parts of the Bowser Moveset this character will have.
    -- Insert each flag you want to be set, separated by '|' symbols.
    local BOWS_FLAGS_KOOPAS = _G.bowsMoveset.FLAG_CAN_USE_SHELL

    -- Flag Options: (sorry the ids are so long pshgkjdf)

    -- _G.bowsMoveset.FLAG_CAN_USE_SHELL
    --- Allows the character to use the shell slide ability.

    -- _G.bowsMoveset.FLAG_CAN_USE_FIREBALL
    --- Allows the character to use the fire breath ability.

    -- _G.bowsMoveset.FLAG_STYLE_ANIMS
    --- Enables Bowser-unique animations for the character.

    -- _G.bowsMoveset.FLAG_SIZE_ANIMS
    --- Adjusts the character's pose in certain animations to suit bowser's large size. (i.e. ledge grab)

    -- _G.bowsMoveset.FLAG_LARGE_HITBOX
    --- Gives the character a larger hitbox size. (37 -> 85 units radius)
    --- This does not affect the hitbox size for level collision, only collisions with objects.

    -- _G.bowsMoveset.FLAG_NO_CAPLESS
    --- The character does not visually lose their 'cap'. Will also use their 'capless' head state in some animations.
    --- Used by Bowser to allow his jaw to open when breathing fire, etc.

    -- _G.bowsMoveset.FLAG_HEAVY_STEPS
    --- Enables heavier landing sound effects for the character.

    -- _G.bowsMoveset.FLAG_ATTACKS
    --- Enables the alternate sliding punch.

    -- _G.bowsMoveset.FLAG_ALL
    --- Shorthand to set all flags.


    -- This function sets up your custom shell model. Feel free to remove this if you aren't using a shell model.
    -- parameters: [your character model], [your shell model]
 
    _G.bowsMoveset.character_add_shell_model(E_MODEL_KOOPS, E_MODEL_SHELL)
    -- This function sets up the flags for your character.
    -- parameters: [your character model], [your flag bitfield]

    _G.bowsMoveset.character_set_bows_flags(E_MODEL_KOOPS, BOWS_FLAGS_KOOPAS)
end
----

char_add_star(E_MODEL_GOOMBELLA, E_MODEL_STAR_CRYSTAL, TEX_STAR_CRYSTAL)
char_add_star(E_MODEL_KOOPS, E_MODEL_STAR_DIAMOND, TEX_STAR_DIAMOND)
char_add_star(E_MODEL_FLURRIE, E_MODEL_STAR_EMERALD, TEX_STAR_EMERALD)
char_add_star(E_MODEL_BY_G_1, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)
char_add_star(E_MODEL_BY_R_2, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)
char_add_star(E_MODEL_BY_B_3, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)
char_add_star(E_MODEL_BY_O_4, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)
char_add_star(E_MODEL_BY_WM_5, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)
char_add_star(E_MODEL_BY_BK_6, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)
char_add_star(E_MODEL_BY_W_7, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)
char_add_star(E_MODEL_VIVIAN, E_MODEL_STAR_RUBY, TEX_STAR_RUBY)
char_add_star(E_MODEL_BOBBERY, E_MODEL_STAR_SAPPHIRE, TEX_STAR_SAPPHIRE)
char_add_star(E_MODEL_MOWZ, E_MODEL_STAR_GARNET, TEX_STAR_GARNET)




_G.charSelect.character_add_health_meter(CT_GOOMBELLA, PM_GOOMBELLA)
_G.charSelect.character_add_health_meter(CT_KOOPS, PM_KOOPA)
_G.charSelect.character_add_health_meter(CT_FLURRIE, PM_FLURRIE)
_G.charSelect.character_add_health_meter(CT_BY, PM_BYOSHI)
_G.charSelect.character_add_health_meter(CT_VIVIAN, PM_VIVIAN)
_G.charSelect.character_add_health_meter(CT_BOBBERY, PM_BOBBERY)
_G.charSelect.character_add_health_meter(CT_MOWZ, PM_MOWZ)

char_add_voice(E_MODEL_GOOMBELLA, VOICETABLE_GOOMBA)
char_add_voice(E_MODEL_KOOPS, VOICETABLE_KOOPA)
char_add_voice(E_MODEL_BOBBERY, VOICETABLE_BOBOMB)
char_add_voice(E_MODEL_MOWZ, VOICETABLE_MOWZ)
char_add_voice(E_MODEL_FLURRIE, VOICETABLE_FLURRIE)
char_add_voice(E_MODEL_BY_G_1, VOICETABLE_BY)
char_add_voice(E_MODEL_BY_R_2, VOICETABLE_BY)
char_add_voice(E_MODEL_BY_B_3, VOICETABLE_BY)
char_add_voice(E_MODEL_BY_O_4, VOICETABLE_BY)
char_add_voice(E_MODEL_BY_WM_5, VOICETABLE_BY)
char_add_voice(E_MODEL_BY_BK_6, VOICETABLE_BY)
char_add_voice(E_MODEL_BY_W_7, VOICETABLE_BY)
char_add_voice(E_MODEL_VIVIAN, VOICETABLE_VIVIAN)



hook_event(HOOK_CHARACTER_SOUND, function(m, sound)
    local v = char_get_voice(m)
    if not v then return end
    if v == VOICETABLE_GOOMBA
        or v == VOICETABLE_KOOPA
        or v == VOICETABLE_BOBOMB
        or v == VOICETABLE_MOWZ
        or v == VOICETABLE_FLURRIE
        or v == VOICETABLE_BY
        or v == VOICETABLE_VIVIAN
        or v == VOICETABLE_SILENT
    then
        return _G.charSelect.voice.sound(m, sound)
    end
end)
hook_event(HOOK_MARIO_UPDATE, function(m)
    local v = char_get_voice(m)
    if not v then return end
    if v == VOICETABLE_GOOMBA
        or v == VOICETABLE_KOOPA
        or v == VOICETABLE_BOBOMB
        or v == VOICETABLE_MOWZ
        or v == VOICETABLE_FLURRIE
        or v == VOICETABLE_BY
        or v == VOICETABLE_VIVIAN
        or v == VOICETABLE_SILENT
    then
        return _G.charSelect.voice.snore(m)
    end
end)
